/**
 * JBibleMidlet.java -   jBible
 */

package jbible.mobile;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.io.*;
import jbible.data.*;
import jbible.mobile.ui.*;
import jbible.mobile.ui.SearchResults;
import jbible.utils.*;

/**
 *  jBible -  
 * @author Konstantin K. Beliak, e-mail: <a href="mailto:smbadm@yandex.ru">smbadm@yandex.ru</a>
 */
public class JBibleMidlet extends MIDlet {
    
    /**
     *    jBible
     */
    private static JBibleMidlet midlet;
    
    /**
     *  
     */
    public JBibleMidlet(){
        super();
    }
    
    /**
     *    
     */
    private ChapterScreen screen;
    
    /**
     *  
     */
    private BibleReader reader;
    
    /**
     *  ,  
     * @throws javax.microedition.midlet.MIDletStateChangeException     
     */
    protected void startApp() throws MIDletStateChangeException {
        midlet=this;
        try{
            reader=new BibleReader();
            screen=new ChapterScreen(reader,null);   
            show(screen);
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    /**
     *       (     )
     */
    public static void reloadScreens(){
        midlet.screen=new ChapterScreen(midlet.reader,midlet.screen.currentPage());
        show(midlet.screen);
    }
    
    /**
     *   (  )
     */
    protected void pauseApp() {
    }

    /**
     *  
     * @param b  
     */
    protected void destroyApp(boolean b) {
        screen.savePage();
        Storage.saveSettings(Common.SETTINGS);
        Bookmark.save();
        midlet.notifyDestroyed();
    }
    
    /**
     *    
     * @param d  
     */
    public static void show(Displayable d){
        Display.getDisplay(midlet).setCurrent(d);        
    }

    /**
     *  
     * @param a 
     * @param next     ,     
     */
    public static void showAlert(Alert a,Displayable next){
        Display.getDisplay(midlet).setCurrent(a,next);
    }
    
    /**
     *   
     */
    public static void quit(){
        midlet.destroyApp(true);
        
    }
}
